<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExtraOpt ArrayType
 * @subpackage Arrays
 */
class ArrayOfExtraOpt extends AbstractStructArrayBase
{
    /**
     * The ExtraOpt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ExtraOpt[]
     */
    public $ExtraOpt;
    /**
     * Constructor method for ArrayOfExtraOpt
     * @uses ArrayOfExtraOpt::setExtraOpt()
     * @param \StructType\ExtraOpt[] $extraOpt
     */
    public function __construct(array $extraOpt = array())
    {
        $this
            ->setExtraOpt($extraOpt);
    }
    /**
     * Get ExtraOpt value
     * @return \StructType\ExtraOpt[]|null
     */
    public function getExtraOpt()
    {
        return $this->ExtraOpt;
    }
    /**
     * This method is responsible for validating the values passed to the setExtraOpt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExtraOpt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExtraOptForArrayConstraintsFromSetExtraOpt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExtraOptExtraOptItem) {
            // validation for constraint: itemType
            if (!$arrayOfExtraOptExtraOptItem instanceof \StructType\ExtraOpt) {
                $invalidValues[] = is_object($arrayOfExtraOptExtraOptItem) ? get_class($arrayOfExtraOptExtraOptItem) : sprintf('%s(%s)', gettype($arrayOfExtraOptExtraOptItem), var_export($arrayOfExtraOptExtraOptItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExtraOpt property can only contain items of type \StructType\ExtraOpt, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExtraOpt value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtraOpt[] $extraOpt
     * @return \ArrayType\ArrayOfExtraOpt
     */
    public function setExtraOpt(array $extraOpt = array())
    {
        // validation for constraint: array
        if ('' !== ($extraOptArrayErrorMessage = self::validateExtraOptForArrayConstraintsFromSetExtraOpt($extraOpt))) {
            throw new \InvalidArgumentException($extraOptArrayErrorMessage, __LINE__);
        }
        $this->ExtraOpt = $extraOpt;
        return $this;
    }
    /**
     * Add item to ExtraOpt value
     * @throws \InvalidArgumentException
     * @param \StructType\ExtraOpt $item
     * @return \ArrayType\ArrayOfExtraOpt
     */
    public function addToExtraOpt(\StructType\ExtraOpt $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExtraOpt) {
            throw new \InvalidArgumentException(sprintf('The ExtraOpt property can only contain items of type \StructType\ExtraOpt, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExtraOpt[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ExtraOpt|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ExtraOpt|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ExtraOpt|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ExtraOpt|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ExtraOpt|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExtraOpt
     */
    public function getAttributeName()
    {
        return 'ExtraOpt';
    }
}
